VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BorderStyle     =   0  'None
   Caption         =   "Form1"
   ClientHeight    =   4995
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7500
   LinkTopic       =   "Form1"
   Picture         =   "Rgn_1.frx":0000
   ScaleHeight     =   333
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   500
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
'Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
'Private Declare Function OleTranslateColor Lib "oleaut32" (ByVal lOleColor As Long, ByVal lHPalette As Long, lColorRef As Long) As Long
Private Declare Function GetTickCount Lib "kernel32" () As Long
Private Const RGN_OR = 2

Private Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFOHEADER, ByVal wUsage As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long

Private Function lGetRegion(ByVal lBackColor As Long, ByVal Picture As StdPicture) As Long
Dim lRgn As Long
Dim lSkinRgn As Long
Dim lStart As Long
Dim lX As Long
Dim lY As Long
Dim ms As Long

Dim bi As BITMAPINFOHEADER, bits() As Long, hdc As Long
With bi
    .biSize = LenB(bi)
    .biWidth = ScaleX(Picture.Width, vbHimetric, vbPixels)
    .biHeight = ScaleY(Picture.Width, vbHimetric, vbPixels)
    .biPlanes = 1
    .biBitCount = 32
    .biCompression = 0
    ReDim bits(0 To .biWidth - 1, 0 To .biHeight - 1)
    hdc = CreateCompatibleDC(0)
    GetDIBits hdc, Picture, 0, bi.biHeight, bits(0, 0), bi, 0
    DeleteDC (hdc)
    
    lSkinRgn = CreateRectRgn(0, 0, 0, 0)

    For lX = 0 To .biHeight - 1
        lY = 0
        Do While lY < .biWidth
            Do While lY < .biWidth
                If bits(lY, lX) <> lBackColor Then Exit Do
                lY = lY + 1
            Loop

            If lY < .biWidth Then
                lStart = lY
                Do While lY < .biWidth
                    If bits(lY, lX) = lBackColor Then Exit Do
                    lY = lY + 1
                Loop
                If lY > .biWidth Then lY = .biWidth
                lRgn = CreateRectRgn(lStart, .biHeight - lX - 1, lY, .biHeight - lX)
                CombineRgn lSkinRgn, lSkinRgn, lRgn, RGN_OR
                DeleteObject lRgn
            End If
        Loop
    Next
End With
lGetRegion = lSkinRgn
End Function

Private Sub Form_DblClick()
    Unload Me
End Sub

Private Sub Form_Load()
Dim lRgn As Long, Start As Long
 Screen.MousePointer = 13
    Show
    Start = GetTickCount
    lRgn = lGetRegion(RGB(239, 239, 239), Picture)
    SetWindowRgn hWnd, lRgn, True
    Debug.Print GetTickCount - Start        '  1482
 Screen.MousePointer = vbDefault
End Sub

